#ifndef GET_ARGUMENTS_H_
#define GET_ARGUMENTS_H_

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

/**
 * @brief Struct to hold pointers to all the possible arguments
 * 
 * @param references_output_file_location The file to write all the token value pairs to
 * @param replacement_token The token for the debug token to be replaced by
 * @param debug_token The token to be used to mark a debug statment` 
 * @param args_list_input_files_indexs The indexes of any input file paths held in the args list 
 * 
 */
typedef struct
{
	char * references_output_file_location;
	char * replacement_token;
	char * debug_token;
	uint8_t * args_list_input_files_indexs;
	char * temp_file_token;
} argsList;

/**
 * @brief Struct holding all the changeable arguments for the program. Initialised with defaults. This will be global.
 * 
 */
extern argsList application_arguments;

uint8_t CheckArguments (argsList * app_arguments, int argc, char ** argv);
void PrintInputFilePaths(argsList * app_arguments, char ** argv);
#endif