#ifndef GET_ARGUMENTS_H_
#define GET_ARGUMENTS_H_

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

/**
 * @brief Struct to hold pointers to all the possible arguments
 * 
 * @param ref_file_location String of path to the References file
 * @param com_port String name of the COM port to be opened
 * @param baudrate UL integer baudrate
 * @param test_string Test string to be sent over the serial port after initialisation
 * 
 */
typedef struct
{
	char * ref_file_location;
	char * com_port;
	uint32_t baudrate;
	char * test_string;
} argsList;

/**
 * @brief Struct holding all the changeable arguments for the program. Initialised with defaults. This will be global.
 * 
 */
extern argsList application_arguments;

void CheckArguments (argsList * app_arguments, int argc, char ** argv);
#endif